<template>
	<li class="nav-item dropdown">
        <a class="nav-link" href="#" data-toggle="dropdown" aria-expanded="false" @click.prevent="notyChat()" >
            <i class="fa fa-comment-o"></i>
            <span class="hidden-md-up ml-1">Mensajes</span>
            <span v-if="count > 0" class="tag tag-alert top"> {{ count }} </span>
        </a>
        <div class="dropdown-messages dropdown-tasks dropdown-menu dropdown-menu-right animated fadeInUp">

	        <div class="m-item" v-for="(notyChat, index ) in notyChats">
	            <div class="mi-icon bg-success"><i class="fa fa-comment-o"></i></div>
                <div class="mi-text">
                	<a class="text-black" href="/chat">Tienes {{notyChat.count}} mensajes de {{notyChat.user.name}}</a>
               	</div> 
	        </div>
	        
	        <a class="dropdown-more" href="/chat">
	            <strong>Ver todas los mensajes</strong>
	        </a>
	    </div>
    </li>
</template>

<script>

import { mapGetters, mapActions  } from 'vuex'

export default {

  	name: 'Chat-icon',

  	data () {
    	return {
    		count:0,
    		notyChats:[]
    	};
  	},

  	computed: {         
        ...mapGetters([
           'chats','chat'
        ])
    },

     methods: {
        ...mapActions([
            'getChats',            
            'changeCurrentChat',          
         ]), 

        countChatIcon: function () {
        	axios.get('/getCountSmsChatIcon')
			.then((response) => {
                this.count = response.data; 
			})
            .catch(err => {});
        },
        notyChat: function () {
        	axios.get('/getNotyChat')
			.then((response) => {
                var URL = this.$el.baseURI;
                if(URL.indexOf("chat") < 0){
                    this.notyChats = response.data;
                }else{
                    this.count = 0;
                }
			});
        }
    },

    created(){
        this.getChats();
        this.countChatIcon(); 
    },

  	mounted(){
                
            Echo.channel('chat-channel')
                .listen('ChatMessageWasReceived', data => {
                		for (var i = this.chats.length - 1; i >= 0; i--) {
                           
                            if(this.chats[i]['user']['id'] == data.chatMessage.emitter_user_id && this.chats[i]['auth'] == data.chatMessage.receiver_user_id){
                                
                                /* chat abierto?*/
                                if(this.chats[i]['assignmentTeacher'] == data.chatMessage.assignment_teacher_id){

                                    if(this.chat.user_id == data.chatMessage.emitter_user_id && this.chat.id == data.chatMessage.assignment_teacher_id){
                                        this.chat.messages.push(data.chatMessage);
                                        $(".m-chat").animate({ scrollTop: $('.m-chat')[0].scrollHeight}, 500);
                                        this.chats[i].unread  = 0 ;
                                    }else{
                                        this.chats[i].unread += 1 ;
                                        var URL = this.$el.baseURI;
                                        if(URL.indexOf("chat") < 0){
                                            if(this.chats[i]['assignmentTeacher'] == data.chatMessage.assignment_teacher_id){
                                                this.count += 1;
                                            }
                                        }else{
                                            this.count = 0;
                                        } 
                                    }
                                }      
                            }

                        }
                    
                });
    } 

};
</script>


